// smart_assert.h

// Boost.SmartAssert library
//
// Copyright (C) 2003 John Torjo (john@torjo.com)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
 
// See http://www.boost.org for updates, documentation, and revision history.

#ifndef BOOST_SMART_ASSERT_HPP_INCLUDED
#define BOOST_SMART_ASSERT_HPP_INCLUDED

#if _MSC_VER >= 1020
#pragma once
#endif

#include <boost/config.hpp>
#ifdef BOOST_MSVC
#pragma warning (disable : 4786)
#endif

// thanks Pavel Vozenilek!
#ifdef __BORLANDC__
#pragma warn -8027  // functions not expanded inline
#pragma warn -8026  // functions with exception spec not expanded inline
#endif

#include <boost/smart_assert/smart_assert.hpp>
#include <boost/smart_assert/smart_enforce.hpp>
#include <boost/smart_assert/smart_verify.hpp>

#include <boost/smart_assert/smart_assert_settings.hpp>


// thanks Pavel Vozenilek!
#ifdef __BORLANDC__
#pragma warn .8027
#pragma warn .8026
#endif


#endif
